//++
//|                                JQS The best peaks of a zigzag v1.0.0 |
//|                                       Copyright  2010, JQS aka Joo. |
//|                                     http://www.mql4.com/ru/users/joo |
//++
#property copyright "Copyright  2010, JQS aka Joo."                   //|
#property link      "http://www.mql4.com/ru/users/joo"                 //|
//++
#property description "The script goes over the parameters of the"     //|
#property description "ZigZag indicator to determine the best value "  //|
#property description "with the greatest theoretical profitability."   //|
//++
#property script_show_inputs                                           //|
//++

//
//----------------------Input Variables---------------------------------
input  int    History=100;
input  double Spred  =80.0; 
input  int    Depth  =5;   //For "one-time" usage
input  bool   loop   =true;//Use search or not
//

//
//--------------------------Program Body--------------------------------
void OnStart()
{
  //-----------------------Variables------------------------------------
  double ZigzagBuffer [];//For storing buffer of the ZZ indicator
  double PeaksOfZigzag[];//For storing the extremum values of ZZ
  int    Zigzag_handle;  //Marker of indicator

  ArraySetAsSeries(ZigzagBuffer,true);
  ArrayResize(PeaksOfZigzag,History);

  int    depth=3;
  double PipsSum=0.0;
  int    PeaksCount=0;
  bool   flag=true;
  //--------------------------------------------------------------------
  if (loop==true)
  {
    while (depth<200 && flag==true)
    {
      //-----------------------------------------------------------
      Zigzag_handle=iCustom(NULL,0,"ZigZag",depth);
      //--- reset error code
      ResetLastError();
      //--- try to copy values of indicator
      for (int i=0;i<100;i++)
      {
        if (BarsCalculated(Zigzag_handle)>0)
          break;
        Sleep(1000);
      }
      int copied=CopyBuffer(Zigzag_handle,0,0,History,ZigzagBuffer);
      if (copied<=0)
      {
        Print("Cannot copy the indicator buffer. Error =",GetLastError(),"  copied=",copied);
        return;
      }
      //-----------------------------------------------------------
      PipsSum=0.0;
      PeaksCount=0;
      for (int u=0;u<History;u++)
      {
        if (NormalizeDouble(ZigzagBuffer[u],Digits())>0.0)
        {
          PeaksOfZigzag[PeaksCount]=NormalizeDouble(ZigzagBuffer[u],Digits());
          PeaksCount++;
        }
      }
      //-----------------------------------------------------------
      for (int V=0;V<PeaksCount-1;V++)
        PipsSum+=NormalizeDouble((MathAbs(PeaksOfZigzag[V]-PeaksOfZigzag[V+1]))/Point(),Digits())-Spred;
      //-----------------------------------------------------------
      if (PeaksCount<=2)
        flag=false;
      else
      {
        Print(depth," ",PeaksCount," ",PipsSum);
        depth+=1;
      }
      //-----------------------------------------------------------
    }
  }
  else
  {
    //-----------------------------------------------------------
    Zigzag_handle=iCustom(NULL,0,"ZigZag",Depth);
    //--- reset error code
    ResetLastError();
    //--- try to copy values of indicator
    for (int i=0;i<History;i++)
    {
      if (BarsCalculated(Zigzag_handle)>0)
        break;
      Sleep(1000);
    }
    int copied=CopyBuffer(Zigzag_handle,0,0,History,ZigzagBuffer);
    if (copied<=0)
    {
      Print("Cannot copy the indicator buffer. Error =",GetLastError(),"  copied=",copied);
      return;
    }
    //-----------------------------------------------------------
    for (int u=0;u<History;u++)
    {
      if (NormalizeDouble(ZigzagBuffer[u],Digits())>0.0)
      {
        PeaksOfZigzag[PeaksCount]=NormalizeDouble(ZigzagBuffer[u],Digits());
        PeaksCount++;
      }
    }
    //-----------------------------------------------------------
    for (int V=0;V<PeaksCount-1;V++)
    {
      PipsSum+=NormalizeDouble((MathAbs(PeaksOfZigzag[V]-PeaksOfZigzag[V+1]))/Point(),Digits())-Spred;
    }
    Print(Depth," ",PeaksCount," ",PipsSum);
    //-----------------------------------------------------------
  }
}
//
